/**
 *  Copyright (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  Licensed under the GPL, Version 3.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/gpl.html
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * --------------------------------------------------------------------------
 *  版权 (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  本开源软件遵循 GPL 3.0 协议;
 *  如果您不遵循此协议，则不被允许使用此文件。
 *  你可以从下面的地址获取完整的协议文本
 *
 *       http://www.gnu.org/licenses/gpl.html
 */
package org.tinygroup.ruleengine.expression.bool;

import org.tinygroup.ruleengine.expression.ExpressionContainer;
import org.tinygroup.ruleengine.expression.IExpression;

public class MultiBoolExpression extends ExpressionContainer<Boolean> {
	public static final String AND = "and";
	public static final String OR = "or";
	private String mode = AND;

	public String getMode() {
		return mode;
	}

	public void setMode(String mode) {
		this.mode = mode;
	}

	public String getName() {
		return "multibool";
	}

	@SuppressWarnings("unchecked")
	public Boolean evaluate() {
		boolean ret = true;
		if (mode == null) {
			mode = AND;
		}
		if (getSubExpressions() != null) {
			for (Object e : getSubExpressions()) {
				IExpression<Boolean> expression = (IExpression<Boolean>) e;
				expression.setRuleSession(getRuleSession());
				Boolean b = expression.evaluate();
				if (mode.equals(AND)) {
					if (!b) {
						ret = false;
						break;
					}
				} else {
					if (b) {
						ret = true;
						break;
					}
				}
			}
		}
		return ret;
	}
}
