/**
 *  Copyright (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  Licensed under the GPL, Version 3.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/gpl.html
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * --------------------------------------------------------------------------
 *  版权 (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  本开源软件遵循 GPL 3.0 协议;
 *  如果您不遵循此协议，则不被允许使用此文件。
 *  你可以从下面的地址获取完整的协议文本
 *
 *       http://www.gnu.org/licenses/gpl.html
 */
package org.tinygroup.ruleengine.expression.decisiontable;

import java.util.HashMap;
import java.util.Map;

public class DecisionTableValue {
	// key为action或condition的title
	// value为HashMap<String, String>，点位符对应表
	// Map<String, String> 中的key为占用符，value为占位符对应的值
	private Map<String, Map<String, String>> valueTable;

	public Map<String, Map<String, String>> getValueTable() {
		return valueTable;
	}

	public void setValueTable(Map<String, Map<String, String>> valueTable) {
		this.valueTable = valueTable;
	}

	public void setValue(String title, String key, String value) {
		if (valueTable == null) {
			valueTable = new HashMap<String, Map<String, String>>();
		}
		Map<String, String> map = valueTable.get(title);
		if (map == null) {
			map = new HashMap<String, String>();
			valueTable.put(title, map);
		}
		map.put(key, value);
	}

}
